import { addSchema } from "@kubernetes-models/apimachinery/_schemas/IoK8sApimachineryPkgApisMetaV1ObjectMeta";
import { Model, setSchema, createTypeMetaGuard } from "@kubernetes-models/base";
import { register } from "@kubernetes-models/validate";
const schemaId = "gateway.networking.k8s.io.v1alpha2.BackendTLSPolicy";
const schema = "{\"type\":\"object\",\"properties\":{\"apiVersion\":{\"type\":\"string\",\"enum\":[\"gateway.networking.k8s.io/v1alpha2\"]},\"kind\":{\"type\":\"string\",\"enum\":[\"BackendTLSPolicy\"]},\"metadata\":{\"oneOf\":[{\"$ref\":\"io.k8s.apimachinery.pkg.apis.meta.v1.ObjectMeta#\"},{\"type\":\"null\"}]},\"spec\":{\"properties\":{\"targetRef\":{\"properties\":{\"group\":{\"maxLength\":253,\"type\":\"string\",\"pattern\":\"^$|^[a-z0-9]([-a-z0-9]*[a-z0-9])?(\\\\.[a-z0-9]([-a-z0-9]*[a-z0-9])?)*$\"},\"kind\":{\"maxLength\":63,\"minLength\":1,\"type\":\"string\",\"pattern\":\"^[a-zA-Z]([-a-zA-Z0-9]*[a-zA-Z0-9])?$\"},\"name\":{\"maxLength\":253,\"minLength\":1,\"type\":\"string\"},\"namespace\":{\"maxLength\":63,\"minLength\":1,\"type\":\"string\",\"pattern\":\"^[a-z0-9]([-a-z0-9]*[a-z0-9])?$\",\"nullable\":true},\"sectionName\":{\"maxLength\":253,\"minLength\":1,\"type\":\"string\",\"pattern\":\"^[a-z0-9]([-a-z0-9]*[a-z0-9])?(\\\\.[a-z0-9]([-a-z0-9]*[a-z0-9])?)*$\",\"nullable\":true}},\"required\":[\"group\",\"kind\",\"name\"],\"type\":\"object\"},\"tls\":{\"properties\":{\"caCertRefs\":{\"items\":{\"properties\":{\"group\":{\"maxLength\":253,\"type\":\"string\",\"pattern\":\"^$|^[a-z0-9]([-a-z0-9]*[a-z0-9])?(\\\\.[a-z0-9]([-a-z0-9]*[a-z0-9])?)*$\"},\"kind\":{\"maxLength\":63,\"minLength\":1,\"type\":\"string\",\"pattern\":\"^[a-zA-Z]([-a-zA-Z0-9]*[a-zA-Z0-9])?$\"},\"name\":{\"maxLength\":253,\"minLength\":1,\"type\":\"string\"}},\"required\":[\"group\",\"kind\",\"name\"],\"type\":\"object\"},\"maxItems\":8,\"type\":\"array\",\"nullable\":true},\"hostname\":{\"maxLength\":253,\"minLength\":1,\"type\":\"string\",\"pattern\":\"^[a-z0-9]([-a-z0-9]*[a-z0-9])?(\\\\.[a-z0-9]([-a-z0-9]*[a-z0-9])?)*$\"},\"wellKnownCACerts\":{\"enum\":[\"System\"],\"type\":\"string\",\"nullable\":true}},\"required\":[\"hostname\"],\"type\":\"object\"}},\"required\":[\"targetRef\",\"tls\"],\"type\":\"object\"},\"status\":{\"properties\":{\"ancestors\":{\"items\":{\"properties\":{\"ancestorRef\":{\"properties\":{\"group\":{\"default\":\"gateway.networking.k8s.io\",\"maxLength\":253,\"type\":\"string\",\"pattern\":\"^$|^[a-z0-9]([-a-z0-9]*[a-z0-9])?(\\\\.[a-z0-9]([-a-z0-9]*[a-z0-9])?)*$\",\"nullable\":true},\"kind\":{\"default\":\"Gateway\",\"maxLength\":63,\"minLength\":1,\"type\":\"string\",\"pattern\":\"^[a-zA-Z]([-a-zA-Z0-9]*[a-zA-Z0-9])?$\",\"nullable\":true},\"name\":{\"maxLength\":253,\"minLength\":1,\"type\":\"string\"},\"namespace\":{\"maxLength\":63,\"minLength\":1,\"type\":\"string\",\"pattern\":\"^[a-z0-9]([-a-z0-9]*[a-z0-9])?$\",\"nullable\":true},\"port\":{\"format\":\"int32\",\"type\":\"integer\",\"minimum\":1,\"maximum\":65535,\"nullable\":true},\"sectionName\":{\"maxLength\":253,\"minLength\":1,\"type\":\"string\",\"pattern\":\"^[a-z0-9]([-a-z0-9]*[a-z0-9])?(\\\\.[a-z0-9]([-a-z0-9]*[a-z0-9])?)*$\",\"nullable\":true}},\"required\":[\"name\"],\"type\":\"object\"},\"conditions\":{\"items\":{\"properties\":{\"lastTransitionTime\":{\"format\":\"date-time\",\"type\":\"string\"},\"message\":{\"maxLength\":32768,\"type\":\"string\"},\"observedGeneration\":{\"format\":\"int64\",\"type\":\"integer\",\"minimum\":0,\"nullable\":true},\"reason\":{\"maxLength\":1024,\"minLength\":1,\"type\":\"string\",\"pattern\":\"^[A-Za-z]([A-Za-z0-9_,:]*[A-Za-z0-9_])?$\"},\"status\":{\"enum\":[\"True\",\"False\",\"Unknown\"],\"type\":\"string\"},\"type\":{\"maxLength\":316,\"type\":\"string\",\"pattern\":\"^([a-z0-9]([-a-z0-9]*[a-z0-9])?(\\\\.[a-z0-9]([-a-z0-9]*[a-z0-9])?)*\\\\/)?(([A-Za-z0-9][-A-Za-z0-9_.]*)?[A-Za-z0-9])$\"}},\"required\":[\"lastTransitionTime\",\"message\",\"reason\",\"status\",\"type\"],\"type\":\"object\"},\"maxItems\":8,\"minItems\":1,\"type\":\"array\",\"nullable\":true},\"controllerName\":{\"maxLength\":253,\"minLength\":1,\"type\":\"string\",\"pattern\":\"^[a-z0-9]([-a-z0-9]*[a-z0-9])?(\\\\.[a-z0-9]([-a-z0-9]*[a-z0-9])?)*\\\\/[A-Za-z0-9\\\\/\\\\-._~%!$&'()*+,;=:]+$\"}},\"required\":[\"ancestorRef\",\"controllerName\"],\"type\":\"object\"},\"maxItems\":16,\"type\":\"array\"}},\"required\":[\"ancestors\"],\"type\":\"object\",\"nullable\":true}},\"required\":[\"spec\",\"apiVersion\",\"kind\"]}";
let parsed;
/**
 * BackendTLSPolicy provides a way to configure how a Gateway connects to a Backend via TLS.
 */
export class BackendTLSPolicy extends Model {
    constructor(data) {
        super({
            apiVersion: BackendTLSPolicy.apiVersion,
            kind: BackendTLSPolicy.kind,
            ...data
        });
    }
}
BackendTLSPolicy.apiVersion = "gateway.networking.k8s.io/v1alpha2";
BackendTLSPolicy.kind = "BackendTLSPolicy";
BackendTLSPolicy.is = createTypeMetaGuard(BackendTLSPolicy);
setSchema(BackendTLSPolicy, schemaId, () => {
    addSchema();
    if (!parsed)
        parsed = JSON.parse(schema);
    register(schemaId, parsed);
});
