import { addSchema } from "@kubernetes-models/apimachinery/_schemas/IoK8sApimachineryPkgApisMetaV1ObjectMeta";
import { Model, setSchema, createTypeMetaGuard } from "@kubernetes-models/base";
import { register } from "@kubernetes-models/validate";
const schemaId = "gateway.networking.k8s.io.v1alpha2.TCPRoute";
const schema = "{\"type\":\"object\",\"properties\":{\"apiVersion\":{\"type\":\"string\",\"enum\":[\"gateway.networking.k8s.io/v1alpha2\"]},\"kind\":{\"type\":\"string\",\"enum\":[\"TCPRoute\"]},\"metadata\":{\"oneOf\":[{\"$ref\":\"io.k8s.apimachinery.pkg.apis.meta.v1.ObjectMeta#\"},{\"type\":\"null\"}]},\"spec\":{\"properties\":{\"parentRefs\":{\"items\":{\"properties\":{\"group\":{\"default\":\"gateway.networking.k8s.io\",\"maxLength\":253,\"type\":\"string\",\"pattern\":\"^$|^[a-z0-9]([-a-z0-9]*[a-z0-9])?(\\\\.[a-z0-9]([-a-z0-9]*[a-z0-9])?)*$\",\"nullable\":true},\"kind\":{\"default\":\"Gateway\",\"maxLength\":63,\"minLength\":1,\"type\":\"string\",\"pattern\":\"^[a-zA-Z]([-a-zA-Z0-9]*[a-zA-Z0-9])?$\",\"nullable\":true},\"name\":{\"maxLength\":253,\"minLength\":1,\"type\":\"string\"},\"namespace\":{\"maxLength\":63,\"minLength\":1,\"type\":\"string\",\"pattern\":\"^[a-z0-9]([-a-z0-9]*[a-z0-9])?$\",\"nullable\":true},\"port\":{\"format\":\"int32\",\"type\":\"integer\",\"minimum\":1,\"maximum\":65535,\"nullable\":true},\"sectionName\":{\"maxLength\":253,\"minLength\":1,\"type\":\"string\",\"pattern\":\"^[a-z0-9]([-a-z0-9]*[a-z0-9])?(\\\\.[a-z0-9]([-a-z0-9]*[a-z0-9])?)*$\",\"nullable\":true}},\"required\":[\"name\"],\"type\":\"object\"},\"maxItems\":32,\"type\":\"array\",\"nullable\":true},\"rules\":{\"items\":{\"properties\":{\"backendRefs\":{\"items\":{\"properties\":{\"group\":{\"default\":\"\",\"maxLength\":253,\"type\":\"string\",\"pattern\":\"^$|^[a-z0-9]([-a-z0-9]*[a-z0-9])?(\\\\.[a-z0-9]([-a-z0-9]*[a-z0-9])?)*$\",\"nullable\":true},\"kind\":{\"default\":\"Service\",\"maxLength\":63,\"minLength\":1,\"type\":\"string\",\"pattern\":\"^[a-zA-Z]([-a-zA-Z0-9]*[a-zA-Z0-9])?$\",\"nullable\":true},\"name\":{\"maxLength\":253,\"minLength\":1,\"type\":\"string\"},\"namespace\":{\"maxLength\":63,\"minLength\":1,\"type\":\"string\",\"pattern\":\"^[a-z0-9]([-a-z0-9]*[a-z0-9])?$\",\"nullable\":true},\"port\":{\"format\":\"int32\",\"type\":\"integer\",\"minimum\":1,\"maximum\":65535,\"nullable\":true},\"weight\":{\"default\":1,\"format\":\"int32\",\"type\":\"integer\",\"minimum\":0,\"maximum\":1000000,\"nullable\":true}},\"required\":[\"name\"],\"type\":\"object\"},\"maxItems\":16,\"minItems\":1,\"type\":\"array\",\"nullable\":true}},\"type\":\"object\"},\"maxItems\":16,\"minItems\":1,\"type\":\"array\"}},\"required\":[\"rules\"],\"type\":\"object\"},\"status\":{\"properties\":{\"parents\":{\"items\":{\"properties\":{\"conditions\":{\"items\":{\"properties\":{\"lastTransitionTime\":{\"format\":\"date-time\",\"type\":\"string\"},\"message\":{\"maxLength\":32768,\"type\":\"string\"},\"observedGeneration\":{\"format\":\"int64\",\"type\":\"integer\",\"minimum\":0,\"nullable\":true},\"reason\":{\"maxLength\":1024,\"minLength\":1,\"type\":\"string\",\"pattern\":\"^[A-Za-z]([A-Za-z0-9_,:]*[A-Za-z0-9_])?$\"},\"status\":{\"enum\":[\"True\",\"False\",\"Unknown\"],\"type\":\"string\"},\"type\":{\"maxLength\":316,\"type\":\"string\",\"pattern\":\"^([a-z0-9]([-a-z0-9]*[a-z0-9])?(\\\\.[a-z0-9]([-a-z0-9]*[a-z0-9])?)*\\\\/)?(([A-Za-z0-9][-A-Za-z0-9_.]*)?[A-Za-z0-9])$\"}},\"required\":[\"lastTransitionTime\",\"message\",\"reason\",\"status\",\"type\"],\"type\":\"object\"},\"maxItems\":8,\"minItems\":1,\"type\":\"array\",\"nullable\":true},\"controllerName\":{\"maxLength\":253,\"minLength\":1,\"type\":\"string\",\"pattern\":\"^[a-z0-9]([-a-z0-9]*[a-z0-9])?(\\\\.[a-z0-9]([-a-z0-9]*[a-z0-9])?)*\\\\/[A-Za-z0-9\\\\/\\\\-._~%!$&'()*+,;=:]+$\"},\"parentRef\":{\"properties\":{\"group\":{\"default\":\"gateway.networking.k8s.io\",\"maxLength\":253,\"type\":\"string\",\"pattern\":\"^$|^[a-z0-9]([-a-z0-9]*[a-z0-9])?(\\\\.[a-z0-9]([-a-z0-9]*[a-z0-9])?)*$\",\"nullable\":true},\"kind\":{\"default\":\"Gateway\",\"maxLength\":63,\"minLength\":1,\"type\":\"string\",\"pattern\":\"^[a-zA-Z]([-a-zA-Z0-9]*[a-zA-Z0-9])?$\",\"nullable\":true},\"name\":{\"maxLength\":253,\"minLength\":1,\"type\":\"string\"},\"namespace\":{\"maxLength\":63,\"minLength\":1,\"type\":\"string\",\"pattern\":\"^[a-z0-9]([-a-z0-9]*[a-z0-9])?$\",\"nullable\":true},\"port\":{\"format\":\"int32\",\"type\":\"integer\",\"minimum\":1,\"maximum\":65535,\"nullable\":true},\"sectionName\":{\"maxLength\":253,\"minLength\":1,\"type\":\"string\",\"pattern\":\"^[a-z0-9]([-a-z0-9]*[a-z0-9])?(\\\\.[a-z0-9]([-a-z0-9]*[a-z0-9])?)*$\",\"nullable\":true}},\"required\":[\"name\"],\"type\":\"object\"}},\"required\":[\"controllerName\",\"parentRef\"],\"type\":\"object\"},\"maxItems\":32,\"type\":\"array\"}},\"required\":[\"parents\"],\"type\":\"object\",\"nullable\":true}},\"required\":[\"spec\",\"apiVersion\",\"kind\"]}";
let parsed;
/**
 * TCPRoute provides a way to route TCP requests. When combined with a Gateway listener, it can be used to forward connections on the port specified by the listener to a set of backends specified by the TCPRoute.
 */
export class TCPRoute extends Model {
    constructor(data) {
        super({
            apiVersion: TCPRoute.apiVersion,
            kind: TCPRoute.kind,
            ...data
        });
    }
}
TCPRoute.apiVersion = "gateway.networking.k8s.io/v1alpha2";
TCPRoute.kind = "TCPRoute";
TCPRoute.is = createTypeMetaGuard(TCPRoute);
setSchema(TCPRoute, schemaId, () => {
    addSchema();
    if (!parsed)
        parsed = JSON.parse(schema);
    register(schemaId, parsed);
});
