import { addSchema } from "@kubernetes-models/apimachinery/_schemas/IoK8sApimachineryPkgApisMetaV1ObjectMeta";
import { Model, setSchema, createTypeMetaGuard } from "@kubernetes-models/base";
import { register } from "@kubernetes-models/validate";
const schemaId = "gateway.networking.k8s.io.v1alpha2.GRPCRoute";
const schema = "{\"type\":\"object\",\"properties\":{\"apiVersion\":{\"type\":\"string\",\"enum\":[\"gateway.networking.k8s.io/v1alpha2\"]},\"kind\":{\"type\":\"string\",\"enum\":[\"GRPCRoute\"]},\"metadata\":{\"oneOf\":[{\"$ref\":\"io.k8s.apimachinery.pkg.apis.meta.v1.ObjectMeta#\"},{\"type\":\"null\"}]},\"spec\":{\"properties\":{\"hostnames\":{\"items\":{\"maxLength\":253,\"minLength\":1,\"type\":\"string\",\"pattern\":\"^(\\\\*\\\\.)?[a-z0-9]([-a-z0-9]*[a-z0-9])?(\\\\.[a-z0-9]([-a-z0-9]*[a-z0-9])?)*$\"},\"maxItems\":16,\"type\":\"array\",\"nullable\":true},\"parentRefs\":{\"items\":{\"properties\":{\"group\":{\"default\":\"gateway.networking.k8s.io\",\"maxLength\":253,\"type\":\"string\",\"pattern\":\"^$|^[a-z0-9]([-a-z0-9]*[a-z0-9])?(\\\\.[a-z0-9]([-a-z0-9]*[a-z0-9])?)*$\",\"nullable\":true},\"kind\":{\"default\":\"Gateway\",\"maxLength\":63,\"minLength\":1,\"type\":\"string\",\"pattern\":\"^[a-zA-Z]([-a-zA-Z0-9]*[a-zA-Z0-9])?$\",\"nullable\":true},\"name\":{\"maxLength\":253,\"minLength\":1,\"type\":\"string\"},\"namespace\":{\"maxLength\":63,\"minLength\":1,\"type\":\"string\",\"pattern\":\"^[a-z0-9]([-a-z0-9]*[a-z0-9])?$\",\"nullable\":true},\"port\":{\"format\":\"int32\",\"type\":\"integer\",\"minimum\":1,\"maximum\":65535,\"nullable\":true},\"sectionName\":{\"maxLength\":253,\"minLength\":1,\"type\":\"string\",\"pattern\":\"^[a-z0-9]([-a-z0-9]*[a-z0-9])?(\\\\.[a-z0-9]([-a-z0-9]*[a-z0-9])?)*$\",\"nullable\":true}},\"required\":[\"name\"],\"type\":\"object\"},\"maxItems\":32,\"type\":\"array\",\"nullable\":true},\"rules\":{\"items\":{\"properties\":{\"backendRefs\":{\"items\":{\"properties\":{\"filters\":{\"items\":{\"properties\":{\"extensionRef\":{\"properties\":{\"group\":{\"maxLength\":253,\"type\":\"string\",\"pattern\":\"^$|^[a-z0-9]([-a-z0-9]*[a-z0-9])?(\\\\.[a-z0-9]([-a-z0-9]*[a-z0-9])?)*$\"},\"kind\":{\"maxLength\":63,\"minLength\":1,\"type\":\"string\",\"pattern\":\"^[a-zA-Z]([-a-zA-Z0-9]*[a-zA-Z0-9])?$\"},\"name\":{\"maxLength\":253,\"minLength\":1,\"type\":\"string\"}},\"required\":[\"group\",\"kind\",\"name\"],\"type\":\"object\",\"nullable\":true},\"requestHeaderModifier\":{\"properties\":{\"add\":{\"items\":{\"properties\":{\"name\":{\"maxLength\":256,\"minLength\":1,\"type\":\"string\",\"pattern\":\"^[A-Za-z0-9!#$%&'*+\\\\-.^_\\\\x60|~]+$\"},\"value\":{\"maxLength\":4096,\"minLength\":1,\"type\":\"string\"}},\"required\":[\"name\",\"value\"],\"type\":\"object\"},\"maxItems\":16,\"type\":\"array\",\"nullable\":true},\"remove\":{\"items\":{\"type\":\"string\"},\"maxItems\":16,\"type\":\"array\",\"nullable\":true},\"set\":{\"items\":{\"properties\":{\"name\":{\"maxLength\":256,\"minLength\":1,\"type\":\"string\",\"pattern\":\"^[A-Za-z0-9!#$%&'*+\\\\-.^_\\\\x60|~]+$\"},\"value\":{\"maxLength\":4096,\"minLength\":1,\"type\":\"string\"}},\"required\":[\"name\",\"value\"],\"type\":\"object\"},\"maxItems\":16,\"type\":\"array\",\"nullable\":true}},\"type\":\"object\",\"nullable\":true},\"requestMirror\":{\"properties\":{\"backendRef\":{\"properties\":{\"group\":{\"default\":\"\",\"maxLength\":253,\"type\":\"string\",\"pattern\":\"^$|^[a-z0-9]([-a-z0-9]*[a-z0-9])?(\\\\.[a-z0-9]([-a-z0-9]*[a-z0-9])?)*$\",\"nullable\":true},\"kind\":{\"default\":\"Service\",\"maxLength\":63,\"minLength\":1,\"type\":\"string\",\"pattern\":\"^[a-zA-Z]([-a-zA-Z0-9]*[a-zA-Z0-9])?$\",\"nullable\":true},\"name\":{\"maxLength\":253,\"minLength\":1,\"type\":\"string\"},\"namespace\":{\"maxLength\":63,\"minLength\":1,\"type\":\"string\",\"pattern\":\"^[a-z0-9]([-a-z0-9]*[a-z0-9])?$\",\"nullable\":true},\"port\":{\"format\":\"int32\",\"type\":\"integer\",\"minimum\":1,\"maximum\":65535,\"nullable\":true}},\"required\":[\"name\"],\"type\":\"object\"}},\"required\":[\"backendRef\"],\"type\":\"object\",\"nullable\":true},\"responseHeaderModifier\":{\"properties\":{\"add\":{\"items\":{\"properties\":{\"name\":{\"maxLength\":256,\"minLength\":1,\"type\":\"string\",\"pattern\":\"^[A-Za-z0-9!#$%&'*+\\\\-.^_\\\\x60|~]+$\"},\"value\":{\"maxLength\":4096,\"minLength\":1,\"type\":\"string\"}},\"required\":[\"name\",\"value\"],\"type\":\"object\"},\"maxItems\":16,\"type\":\"array\",\"nullable\":true},\"remove\":{\"items\":{\"type\":\"string\"},\"maxItems\":16,\"type\":\"array\",\"nullable\":true},\"set\":{\"items\":{\"properties\":{\"name\":{\"maxLength\":256,\"minLength\":1,\"type\":\"string\",\"pattern\":\"^[A-Za-z0-9!#$%&'*+\\\\-.^_\\\\x60|~]+$\"},\"value\":{\"maxLength\":4096,\"minLength\":1,\"type\":\"string\"}},\"required\":[\"name\",\"value\"],\"type\":\"object\"},\"maxItems\":16,\"type\":\"array\",\"nullable\":true}},\"type\":\"object\",\"nullable\":true},\"type\":{\"enum\":[\"ResponseHeaderModifier\",\"RequestHeaderModifier\",\"RequestMirror\",\"ExtensionRef\"],\"type\":\"string\"}},\"required\":[\"type\"],\"type\":\"object\"},\"maxItems\":16,\"type\":\"array\",\"nullable\":true},\"group\":{\"default\":\"\",\"maxLength\":253,\"type\":\"string\",\"pattern\":\"^$|^[a-z0-9]([-a-z0-9]*[a-z0-9])?(\\\\.[a-z0-9]([-a-z0-9]*[a-z0-9])?)*$\",\"nullable\":true},\"kind\":{\"default\":\"Service\",\"maxLength\":63,\"minLength\":1,\"type\":\"string\",\"pattern\":\"^[a-zA-Z]([-a-zA-Z0-9]*[a-zA-Z0-9])?$\",\"nullable\":true},\"name\":{\"maxLength\":253,\"minLength\":1,\"type\":\"string\"},\"namespace\":{\"maxLength\":63,\"minLength\":1,\"type\":\"string\",\"pattern\":\"^[a-z0-9]([-a-z0-9]*[a-z0-9])?$\",\"nullable\":true},\"port\":{\"format\":\"int32\",\"type\":\"integer\",\"minimum\":1,\"maximum\":65535,\"nullable\":true},\"weight\":{\"default\":1,\"format\":\"int32\",\"type\":\"integer\",\"minimum\":0,\"maximum\":1000000,\"nullable\":true}},\"required\":[\"name\"],\"type\":\"object\"},\"maxItems\":16,\"type\":\"array\",\"nullable\":true},\"filters\":{\"items\":{\"properties\":{\"extensionRef\":{\"properties\":{\"group\":{\"maxLength\":253,\"type\":\"string\",\"pattern\":\"^$|^[a-z0-9]([-a-z0-9]*[a-z0-9])?(\\\\.[a-z0-9]([-a-z0-9]*[a-z0-9])?)*$\"},\"kind\":{\"maxLength\":63,\"minLength\":1,\"type\":\"string\",\"pattern\":\"^[a-zA-Z]([-a-zA-Z0-9]*[a-zA-Z0-9])?$\"},\"name\":{\"maxLength\":253,\"minLength\":1,\"type\":\"string\"}},\"required\":[\"group\",\"kind\",\"name\"],\"type\":\"object\",\"nullable\":true},\"requestHeaderModifier\":{\"properties\":{\"add\":{\"items\":{\"properties\":{\"name\":{\"maxLength\":256,\"minLength\":1,\"type\":\"string\",\"pattern\":\"^[A-Za-z0-9!#$%&'*+\\\\-.^_\\\\x60|~]+$\"},\"value\":{\"maxLength\":4096,\"minLength\":1,\"type\":\"string\"}},\"required\":[\"name\",\"value\"],\"type\":\"object\"},\"maxItems\":16,\"type\":\"array\",\"nullable\":true},\"remove\":{\"items\":{\"type\":\"string\"},\"maxItems\":16,\"type\":\"array\",\"nullable\":true},\"set\":{\"items\":{\"properties\":{\"name\":{\"maxLength\":256,\"minLength\":1,\"type\":\"string\",\"pattern\":\"^[A-Za-z0-9!#$%&'*+\\\\-.^_\\\\x60|~]+$\"},\"value\":{\"maxLength\":4096,\"minLength\":1,\"type\":\"string\"}},\"required\":[\"name\",\"value\"],\"type\":\"object\"},\"maxItems\":16,\"type\":\"array\",\"nullable\":true}},\"type\":\"object\",\"nullable\":true},\"requestMirror\":{\"properties\":{\"backendRef\":{\"properties\":{\"group\":{\"default\":\"\",\"maxLength\":253,\"type\":\"string\",\"pattern\":\"^$|^[a-z0-9]([-a-z0-9]*[a-z0-9])?(\\\\.[a-z0-9]([-a-z0-9]*[a-z0-9])?)*$\",\"nullable\":true},\"kind\":{\"default\":\"Service\",\"maxLength\":63,\"minLength\":1,\"type\":\"string\",\"pattern\":\"^[a-zA-Z]([-a-zA-Z0-9]*[a-zA-Z0-9])?$\",\"nullable\":true},\"name\":{\"maxLength\":253,\"minLength\":1,\"type\":\"string\"},\"namespace\":{\"maxLength\":63,\"minLength\":1,\"type\":\"string\",\"pattern\":\"^[a-z0-9]([-a-z0-9]*[a-z0-9])?$\",\"nullable\":true},\"port\":{\"format\":\"int32\",\"type\":\"integer\",\"minimum\":1,\"maximum\":65535,\"nullable\":true}},\"required\":[\"name\"],\"type\":\"object\"}},\"required\":[\"backendRef\"],\"type\":\"object\",\"nullable\":true},\"responseHeaderModifier\":{\"properties\":{\"add\":{\"items\":{\"properties\":{\"name\":{\"maxLength\":256,\"minLength\":1,\"type\":\"string\",\"pattern\":\"^[A-Za-z0-9!#$%&'*+\\\\-.^_\\\\x60|~]+$\"},\"value\":{\"maxLength\":4096,\"minLength\":1,\"type\":\"string\"}},\"required\":[\"name\",\"value\"],\"type\":\"object\"},\"maxItems\":16,\"type\":\"array\",\"nullable\":true},\"remove\":{\"items\":{\"type\":\"string\"},\"maxItems\":16,\"type\":\"array\",\"nullable\":true},\"set\":{\"items\":{\"properties\":{\"name\":{\"maxLength\":256,\"minLength\":1,\"type\":\"string\",\"pattern\":\"^[A-Za-z0-9!#$%&'*+\\\\-.^_\\\\x60|~]+$\"},\"value\":{\"maxLength\":4096,\"minLength\":1,\"type\":\"string\"}},\"required\":[\"name\",\"value\"],\"type\":\"object\"},\"maxItems\":16,\"type\":\"array\",\"nullable\":true}},\"type\":\"object\",\"nullable\":true},\"type\":{\"enum\":[\"ResponseHeaderModifier\",\"RequestHeaderModifier\",\"RequestMirror\",\"ExtensionRef\"],\"type\":\"string\"}},\"required\":[\"type\"],\"type\":\"object\"},\"maxItems\":16,\"type\":\"array\",\"nullable\":true},\"matches\":{\"items\":{\"properties\":{\"headers\":{\"items\":{\"properties\":{\"name\":{\"maxLength\":256,\"minLength\":1,\"type\":\"string\",\"pattern\":\"^[A-Za-z0-9!#$%&'*+\\\\-.^_\\\\x60|~]+$\"},\"type\":{\"default\":\"Exact\",\"enum\":[\"Exact\",\"RegularExpression\"],\"type\":\"string\",\"nullable\":true},\"value\":{\"maxLength\":4096,\"minLength\":1,\"type\":\"string\"}},\"required\":[\"name\",\"value\"],\"type\":\"object\"},\"maxItems\":16,\"type\":\"array\",\"nullable\":true},\"method\":{\"properties\":{\"method\":{\"maxLength\":1024,\"type\":\"string\",\"nullable\":true},\"service\":{\"maxLength\":1024,\"type\":\"string\",\"nullable\":true},\"type\":{\"default\":\"Exact\",\"enum\":[\"Exact\",\"RegularExpression\"],\"type\":\"string\",\"nullable\":true}},\"type\":\"object\",\"nullable\":true}},\"type\":\"object\"},\"maxItems\":8,\"type\":\"array\",\"nullable\":true}},\"type\":\"object\"},\"maxItems\":16,\"type\":\"array\",\"nullable\":true}},\"type\":\"object\",\"nullable\":true},\"status\":{\"properties\":{\"parents\":{\"items\":{\"properties\":{\"conditions\":{\"items\":{\"properties\":{\"lastTransitionTime\":{\"format\":\"date-time\",\"type\":\"string\"},\"message\":{\"maxLength\":32768,\"type\":\"string\"},\"observedGeneration\":{\"format\":\"int64\",\"type\":\"integer\",\"minimum\":0,\"nullable\":true},\"reason\":{\"maxLength\":1024,\"minLength\":1,\"type\":\"string\",\"pattern\":\"^[A-Za-z]([A-Za-z0-9_,:]*[A-Za-z0-9_])?$\"},\"status\":{\"enum\":[\"True\",\"False\",\"Unknown\"],\"type\":\"string\"},\"type\":{\"maxLength\":316,\"type\":\"string\",\"pattern\":\"^([a-z0-9]([-a-z0-9]*[a-z0-9])?(\\\\.[a-z0-9]([-a-z0-9]*[a-z0-9])?)*\\\\/)?(([A-Za-z0-9][-A-Za-z0-9_.]*)?[A-Za-z0-9])$\"}},\"required\":[\"lastTransitionTime\",\"message\",\"reason\",\"status\",\"type\"],\"type\":\"object\"},\"maxItems\":8,\"minItems\":1,\"type\":\"array\",\"nullable\":true},\"controllerName\":{\"maxLength\":253,\"minLength\":1,\"type\":\"string\",\"pattern\":\"^[a-z0-9]([-a-z0-9]*[a-z0-9])?(\\\\.[a-z0-9]([-a-z0-9]*[a-z0-9])?)*\\\\/[A-Za-z0-9\\\\/\\\\-._~%!$&'()*+,;=:]+$\"},\"parentRef\":{\"properties\":{\"group\":{\"default\":\"gateway.networking.k8s.io\",\"maxLength\":253,\"type\":\"string\",\"pattern\":\"^$|^[a-z0-9]([-a-z0-9]*[a-z0-9])?(\\\\.[a-z0-9]([-a-z0-9]*[a-z0-9])?)*$\",\"nullable\":true},\"kind\":{\"default\":\"Gateway\",\"maxLength\":63,\"minLength\":1,\"type\":\"string\",\"pattern\":\"^[a-zA-Z]([-a-zA-Z0-9]*[a-zA-Z0-9])?$\",\"nullable\":true},\"name\":{\"maxLength\":253,\"minLength\":1,\"type\":\"string\"},\"namespace\":{\"maxLength\":63,\"minLength\":1,\"type\":\"string\",\"pattern\":\"^[a-z0-9]([-a-z0-9]*[a-z0-9])?$\",\"nullable\":true},\"port\":{\"format\":\"int32\",\"type\":\"integer\",\"minimum\":1,\"maximum\":65535,\"nullable\":true},\"sectionName\":{\"maxLength\":253,\"minLength\":1,\"type\":\"string\",\"pattern\":\"^[a-z0-9]([-a-z0-9]*[a-z0-9])?(\\\\.[a-z0-9]([-a-z0-9]*[a-z0-9])?)*$\",\"nullable\":true}},\"required\":[\"name\"],\"type\":\"object\"}},\"required\":[\"controllerName\",\"parentRef\"],\"type\":\"object\"},\"maxItems\":32,\"type\":\"array\"}},\"required\":[\"parents\"],\"type\":\"object\",\"nullable\":true}},\"required\":[\"apiVersion\",\"kind\"]}";
let parsed;
/**
 * GRPCRoute provides a way to route gRPC requests. This includes the capability to match requests by hostname, gRPC service, gRPC method, or HTTP/2 header. Filters can be used to specify additional processing steps. Backends specify where matching requests will be routed.
 *  GRPCRoute falls under extended support within the Gateway API. Within the following specification, the word "MUST" indicates that an implementation supporting GRPCRoute must conform to the indicated requirement, but an implementation not supporting this route type need not follow the requirement unless explicitly indicated.
 *  Implementations supporting `GRPCRoute` with the `HTTPS` `ProtocolType` MUST accept HTTP/2 connections without an initial upgrade from HTTP/1.1, i.e. via ALPN. If the implementation does not support this, then it MUST set the "Accepted" condition to "False" for the affected listener with a reason of "UnsupportedProtocol".  Implementations MAY also accept HTTP/2 connections with an upgrade from HTTP/1.
 *  Implementations supporting `GRPCRoute` with the `HTTP` `ProtocolType` MUST support HTTP/2 over cleartext TCP (h2c, https://www.rfc-editor.org/rfc/rfc7540#section-3.1) without an initial upgrade from HTTP/1.1, i.e. with prior knowledge (https://www.rfc-editor.org/rfc/rfc7540#section-3.4). If the implementation does not support this, then it MUST set the "Accepted" condition to "False" for the affected listener with a reason of "UnsupportedProtocol". Implementations MAY also accept HTTP/2 connections with an upgrade from HTTP/1, i.e. without prior knowledge.
 */
export class GRPCRoute extends Model {
    constructor(data) {
        super({
            apiVersion: GRPCRoute.apiVersion,
            kind: GRPCRoute.kind,
            ...data
        });
    }
}
GRPCRoute.apiVersion = "gateway.networking.k8s.io/v1alpha2";
GRPCRoute.kind = "GRPCRoute";
GRPCRoute.is = createTypeMetaGuard(GRPCRoute);
setSchema(GRPCRoute, schemaId, () => {
    addSchema();
    if (!parsed)
        parsed = JSON.parse(schema);
    register(schemaId, parsed);
});
